# automatically generated by prepareDQM.py
import FWCore.ParameterSet.Config as cms
from PhysicsTools.NanoAOD.nanoDQM_tools_cff import *

from DQMServices.Core.DQMEDAnalyzer import DQMEDAnalyzer
nanoDQM = DQMEDAnalyzer("NanoAODDQM",
    vplots = cms.PSet(
        CaloMET = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 400, 'pt'),
                Plot1D('sumEt', 'sumEt', 20, 200, 3000, 'scalar sum of Et'),
            )
        ),
        ChsMET = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'raw chs PF MET phi'),
                Plot1D('pt', 'pt', 20, 0, 400, 'raw chs PF MET pt'),
                Plot1D('sumEt', 'sumEt', 20, 600, 5000, 'raw chs PF scalar sum of Et'),
            )
        ),
        CorrT1METJet = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Count1D('_size', 20, -0.5, 19.5, 'Additional low-pt jets for Type-1 MET re-correction'),
                Plot1D('area', 'area', 20, 0.2, 0.8, 'jet catchment area, for JECs'),
                Plot1D('eta', 'eta', 20, -5, 5, 'eta'),
                Plot1D('muonSubtrFactor', 'muonSubtrFactor', 20, 0, 1, '1-(muon-subtracted raw pt)/(raw pt)'),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('rawPt', 'rawPt', 20, 5, 25, "pt()*jecFactor('Uncorrected')"),
            )
        ),
        Electron = cms.PSet(
            sels = cms.PSet(
                Good = cms.string('pt > 15 && abs(dxy) < 0.2 && abs(dz) < 0.5 && cutBased >= 3 && miniPFRelIso_all < 0.4')
            ),
            plots = cms.VPSet(
                Count1D('_size', 8, -0.5, 7.5, 'slimmedElectrons after basic selection (pt > 5 )'),
                Plot1D('charge', 'charge', 3, -1.5, 1.5, 'electric charge'),
                Plot1D('cleanmask', 'cleanmask', 1, 0.5, 1.5, 'simple cleaning mask with priority to leptons'),
                Plot1D('convVeto', 'convVeto', 2, -0.5, 1.5, 'pass conversion veto'),
                Plot1D('cutBased', 'cutBased', 5, -0.5, 4.5, 'cut-based ID (0:fail, 1:veto, 2:loose, 3:medium, 4:tight)'),
                Plot1D('cutBased_Fall17_V1', 'cutBased_Fall17_V1', 5, -0.5, 4.5, 'cut-based ID Fall17 V1 (0:fail, 1:veto, 2:loose, 3:medium, 4:tight)'),
                Plot1D('cutBased_HEEP', 'cutBased_HEEP', 2, -0.5, 1.5, 'cut-based HEEP ID'),
                Plot1D('deltaEtaSC', 'deltaEtaSC', 20, -0.2, 0.2, 'delta eta (SC,ele) with sign'),
                Plot1D('dr03EcalRecHitSumEt', 'dr03EcalRecHitSumEt', 20, 0, 30, 'Non-PF Ecal isolation within a delta R cone of 0.3 with electron pt > 35 GeV'),
                Plot1D('dr03HcalDepth1TowerSumEt', 'dr03HcalDepth1TowerSumEt', 20, 0, 20, 'Non-PF Hcal isolation within a delta R cone of 0.3 with electron pt > 35 GeV'),
                Plot1D('dr03TkSumPt', 'dr03TkSumPt', 20, 0, 40, 'Non-PF track isolation within a delta R cone of 0.3 with electron pt > 35 GeV'),
                Plot1D('dr03TkSumPtHEEP', 'dr03TkSumPtHEEP', 20, 0, 40, 'Non-PF track isolation within a delta R cone of 0.3 with electron pt > 35 GeV used in HEEP ID'),
                Plot1D('dxy', 'dxy', 20, -0.1, 0.1, 'dxy (with sign) wrt first PV, in cm'),
                Plot1D('dxyErr', 'dxyErr', 20, 0, 0.2, 'dxy uncertainty, in cm'),
                Plot1D('dz', 'dz', 20, -0.3, 0.3, 'dz (with sign) wrt first PV, in cm'),
                Plot1D('dzErr', 'dzErr', 20, 0, 0.2, 'dz uncertainty, in cm'),
                Plot1D('eCorr', 'eCorr', 20, 0.8, 1.2, 'ratio of the calibrated energy/miniaod energy'),
                Plot1D('eInvMinusPInv', 'eInvMinusPInv', 20, -0.1, 0.1, '1/E_SC - 1/p_trk'),
                Plot1D('energyErr', 'energyErr', 20, 0, 90, 'energy error of the cluster-track combination'),
                Plot1D('eta', 'eta', 20, -3, 3, 'eta'),
                Plot1D('genPartFlav', 'genPartFlav', 20, 0, 30, 'Flavour of genParticle for MC matching to status==1 electrons or photons: 1 = prompt electron (including gamma*->mu mu), 15 = electron from prompt tau, 22 = prompt photon (likely conversion), 5 = electron from b, 4 = electron from c, 3 = electron from light or unknown, 0 = unmatched'),
                NoPlot('genPartIdx'),
                Plot1D('hoe', 'hoe', 20, 0, 1, 'H over E'),
                Plot1D('ip3d', 'ip3d', 20, 0, 0.2, '3D impact parameter wrt first PV, in cm'),
                Plot1D('isPFcand', 'isPFcand', 2, -0.5, 1.5, 'electron is PF candidate'),
                NoPlot('jetIdx'),
                Plot1D('jetPtRelv2', 'jetPtRelv2', 20, 0, 60, 'Relative momentum of the lepton with respect to the closest jet after subtracting the lepton'),
                Plot1D('jetRelIso', 'jetRelIso', 20, -0.2, 1.8, 'Relative isolation in matched jet (1/ptRatio-1, pfRelIso04_all if no matched jet)'),
                Plot1D('lostHits', 'lostHits', 4, -0.5, 3.5, 'number of missing inner hits'),
                NoPlot('mass'),
                Plot1D('miniPFRelIso_all', 'miniPFRelIso_all', 20, 0, 1, 'mini PF relative isolation, total (with scaled rho*EA PU corrections)'),
                Plot1D('miniPFRelIso_chg', 'miniPFRelIso_chg', 20, 0, 1, 'mini PF relative isolation, charged component'),
                Plot1D('mvaFall17V1Iso', 'mvaFall17V1Iso', 20, -1, 1, 'MVA Iso ID V1 score'),
                Plot1D('mvaFall17V1Iso_WP80', 'mvaFall17V1Iso_WP80', 2, -0.5, 1.5, 'MVA Iso ID V1 WP80'),
                Plot1D('mvaFall17V1Iso_WP90', 'mvaFall17V1Iso_WP90', 2, -0.5, 1.5, 'MVA Iso ID V1 WP90'),
                Plot1D('mvaFall17V1Iso_WPL', 'mvaFall17V1Iso_WPL', 2, -0.5, 1.5, 'MVA Iso ID V1 loose WP'),
                Plot1D('mvaFall17V1noIso', 'mvaFall17V1noIso', 20, -1, 1, 'MVA noIso ID V1 score'),
                Plot1D('mvaFall17V1noIso_WP80', 'mvaFall17V1noIso_WP80', 2, -0.5, 1.5, 'MVA noIso ID V1 WP80'),
                Plot1D('mvaFall17V1noIso_WP90', 'mvaFall17V1noIso_WP90', 2, -0.5, 1.5, 'MVA noIso ID V1 WP90'),
                Plot1D('mvaFall17V1noIso_WPL', 'mvaFall17V1noIso_WPL', 2, -0.5, 1.5, 'MVA noIso ID V1 loose WP'),
                Plot1D('mvaFall17V2Iso', 'mvaFall17V2Iso', 20, -1, 1, 'MVA Iso ID V2 score'),
                Plot1D('mvaFall17V2Iso_WP80', 'mvaFall17V2Iso_WP80', 2, -0.5, 1.5, 'MVA Iso ID V2 WP80'),
                Plot1D('mvaFall17V2Iso_WP90', 'mvaFall17V2Iso_WP90', 2, -0.5, 1.5, 'MVA Iso ID V2 WP90'),
                Plot1D('mvaFall17V2Iso_WPL', 'mvaFall17V2Iso_WPL', 2, -0.5, 1.5, 'MVA Iso ID V2 loose WP'),
                Plot1D('mvaFall17V2noIso', 'mvaFall17V2noIso', 20, -1, 1, 'MVA noIso ID V2 score'),
                Plot1D('mvaFall17V2noIso_WP80', 'mvaFall17V2noIso_WP80', 2, -0.5, 1.5, 'MVA noIso ID V2 WP80'),
                Plot1D('mvaFall17V2noIso_WP90', 'mvaFall17V2noIso_WP90', 2, -0.5, 1.5, 'MVA noIso ID V2 WP90'),
                Plot1D('mvaFall17V2noIso_WPL', 'mvaFall17V2noIso_WPL', 2, -0.5, 1.5, 'MVA noIso ID V2 loose WP'),
                Plot1D('mvaTTH', 'mvaTTH', 20, -1, 1, 'TTH MVA lepton ID score'),
                Plot1D('pdgId', 'pdgId', 27, -13.5, 13.5, 'PDG code assigned by the event reconstruction (not by MC truth)'),
                Plot1D('pfRelIso03_all', 'pfRelIso03_all', 20, 0, 2, 'PF relative isolation dR=0.3, total (with rho*EA PU corrections)'),
                Plot1D('pfRelIso03_chg', 'pfRelIso03_chg', 20, 0, 2, 'PF relative isolation dR=0.3, charged component'),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                NoPlot('photonIdx'),
                Plot1D('pt', 'pt', 20, 0, 200, 'pt (corrected)'),
                Plot1D('r9', 'r9', 20, 0, 1.1, 'R9 of the supercluster, calculated with full 5x5 region'),
                Plot1D('scEtOverPt', 'scEtOverPt', 20, -0.5, 0.5, '(supercluster transverse energy)/pt - 1'),
                Plot1D('seedGain', 'seedGain', 12, 0.5, 12.5, 'Gain of the seed crystal'),
                Plot1D('sieie', 'sieie', 20, 0, 0.05, 'sigma_IetaIeta of the supercluster, calculated with full 5x5 region'),
                Plot1D('sip3d', 'sip3d', 20, 0, 20, '3D impact parameter significance wrt first PV, in cm'),
                Plot1D('tightCharge', 'tightCharge', 3, -0.5, 2.5, 'Tight charge criteria (0:none, 1:isGsfScPixChargeConsistent, 2:isGsfCtfScPixChargeConsistent)'),
                NoPlot('vidNestedWPBitmap'),
                NoPlot('vidNestedWPBitmapHEEP'),
            )
        ),
        FatJet = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Count1D('_size', 6, -0.5, 5.5, 'slimmedJetsAK8, i.e. ak8 fat jets for boosted analysis'),
                Plot1D('area', 'area', 20, 2, 4, 'jet catchment area, for JECs'),
                Plot1D('btagCMVA', 'btagCMVA', 20, -1, 1, 'CMVA V2 btag discriminator'),
                Plot1D('btagCSVV2', 'btagCSVV2', 20, -1, 1, ' pfCombinedInclusiveSecondaryVertexV2 b-tag discriminator (aka CSVV2)'),
                Plot1D('btagDDBvL', 'btagDDBvL', 20, -1, 1, 'DeepDoubleX (mass-decorrelated) discriminator for H(Z)->bb vs QCD'),
                Plot1D('btagDDBvL_noMD', 'btagDDBvL_noMD', 20, 0, 1, 'DeepDoubleX discriminator (no mass-decorrelation) for H(Z)->bb vs QCD'),
                Plot1D('btagDDCvB', 'btagDDCvB', 20, -1, 1, 'DeepDoubleX (mass-decorrelated) discriminator for H(Z)->cc vs H(Z)->bb'),
                Plot1D('btagDDCvB_noMD', 'btagDDCvB_noMD', 20, 0, 1, 'DeepDoubleX discriminator (no mass-decorrelation) for H(Z)->cc vs H(Z)->bb'),
                Plot1D('btagDDCvL', 'btagDDCvL', 20, -1, 1, 'DeepDoubleX (mass-decorrelated) discriminator for H(Z)->cc vs QCD'),
                Plot1D('btagDDCvL_noMD', 'btagDDCvL_noMD', 20, 0, 1, 'DeepDoubleX discriminator (no mass-decorrelation) for H(Z)->cc vs QCD'),
                Plot1D('btagDeepB', 'btagDeepB', 20, -1, 1, 'Deep B+BB btag discriminator'),
                Plot1D('btagHbb', 'btagHbb', 20, -1, 1, 'Higgs to BB tagger discriminator'),
                Plot1D('deepTagMD_H4qvsQCD', 'deepTagMD_H4qvsQCD', 20, 0, 1, 'Mass-decorrelated DeepBoostedJet tagger H->4q vs QCD discriminator'),
                Plot1D('deepTagMD_HbbvsQCD', 'deepTagMD_HbbvsQCD', 20, 0, 1, 'Mass-decorrelated DeepBoostedJet tagger H->bb vs QCD discriminator'),
                Plot1D('deepTagMD_TvsQCD', 'deepTagMD_TvsQCD', 20, 0, 1, 'Mass-decorrelated DeepBoostedJet tagger top vs QCD discriminator'),
                Plot1D('deepTagMD_WvsQCD', 'deepTagMD_WvsQCD', 20, 0, 1, 'Mass-decorrelated DeepBoostedJet tagger W vs QCD discriminator'),
                Plot1D('deepTagMD_ZHbbvsQCD', 'deepTagMD_ZHbbvsQCD', 20, 0, 1, 'Mass-decorrelated DeepBoostedJet tagger Z/H->bb vs QCD discriminator'),
                Plot1D('deepTagMD_ZHccvsQCD', 'deepTagMD_ZHccvsQCD', 20, 0, 1, 'Mass-decorrelated DeepBoostedJet tagger Z/H->cc vs QCD discriminator'),
                Plot1D('deepTagMD_ZbbvsQCD', 'deepTagMD_ZbbvsQCD', 20, 0, 1, 'Mass-decorrelated DeepBoostedJet tagger Z->bb vs QCD discriminator'),
                Plot1D('deepTagMD_ZvsQCD', 'deepTagMD_ZvsQCD', 20, 0, 1, 'Mass-decorrelated DeepBoostedJet tagger Z vs QCD discriminator'),
                Plot1D('deepTagMD_bbvsLight', 'deepTagMD_bbvsLight', 20, 0, 1, 'Mass-decorrelated DeepBoostedJet tagger Z/H/gluon->bb vs light flavour discriminator'),
                Plot1D('deepTagMD_ccvsLight', 'deepTagMD_ccvsLight', 20, 0, 1, 'Mass-decorrelated DeepBoostedJet tagger Z/H/gluon->cc vs light flavour discriminator'),
                Plot1D('deepTag_H', 'deepTag_H', 20, 0, 1, 'DeepBoostedJet tagger H(bb,cc,4q) sum'),
                Plot1D('deepTag_QCD', 'deepTag_QCD', 20, 0, 1, 'DeepBoostedJet tagger QCD(bb,cc,b,c,others) sum'),
                Plot1D('deepTag_QCDothers', 'deepTag_QCDothers', 20, 0, 1, 'DeepBoostedJet tagger QCDothers value'),
                Plot1D('deepTag_TvsQCD', 'deepTag_TvsQCD', 20, 0, 1, 'DeepBoostedJet tagger top vs QCD discriminator'),
                Plot1D('deepTag_WvsQCD', 'deepTag_WvsQCD', 20, 0, 1, 'DeepBoostedJet tagger W vs QCD discriminator'),
                Plot1D('deepTag_ZvsQCD', 'deepTag_ZvsQCD', 20, 0, 1, 'DeepBoostedJet tagger Z vs QCD discriminator'),
                NoPlot('electronIdx3SJ'),
                Plot1D('eta', 'eta', 20, -4, 4, 'eta'),
                NoPlot('genJetAK8Idx'),
                Plot1D('hadronFlavour', 'hadronFlavour', 6, -0.5, 5.5, 'flavour from hadron ghost clustering'),
                Plot1D('jetId', 'jetId', 8, -0.5, 7.5, 'Jet ID flags bit1 is loose (always false in 2017 since it does not exist), bit2 is tight, bit3 is tightLepVeto'),
                Plot1D('lsf3', 'lsf3', 20, -1, 1, 'Lepton Subjet Fraction (3 subjets)'),
                Plot1D('mass', 'mass', 20, 0, 300, 'mass'),
                Plot1D('msoftdrop', 'msoftdrop', 20, -300, 300, 'Soft drop mass'),
                NoPlot('muonIdx3SJ'),
                Plot1D('n2b1', 'n2b1', 20, 0, 1, 'N2 (beta=1)'),
                Plot1D('n3b1', 'n3b1', 20, 0, 5, 'N3 (beta=1)'),
                Plot1D('nBHadrons', 'nBHadrons', 4, -0.5, 3.5, 'number of b-hadrons'),
                Plot1D('nCHadrons', 'nCHadrons', 4, -0.5, 3.5, 'number of c-hadrons'),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 800, 'pt'),
                Plot1D('rawFactor', 'rawFactor', 20, -0.5, 0.5, '1 - Factor to get back to raw pT'),
                NoPlot('subJetIdx1'),
                NoPlot('subJetIdx2'),
                Plot1D('tau1', 'tau1', 20, 0, 1, 'Nsubjettiness (1 axis)'),
                Plot1D('tau2', 'tau2', 20, 0, 1, 'Nsubjettiness (2 axis)'),
                Plot1D('tau3', 'tau3', 20, 0, 1, 'Nsubjettiness (3 axis)'),
                Plot1D('tau4', 'tau4', 20, 0, 1, 'Nsubjettiness (4 axis)'),
            )
        ),
        Flag = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Plot1D('BadChargedCandidateFilter', 'BadChargedCandidateFilter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('BadChargedCandidateSummer16Filter', 'BadChargedCandidateSummer16Filter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('BadPFMuonFilter', 'BadPFMuonFilter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('BadPFMuonSummer16Filter', 'BadPFMuonSummer16Filter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('CSCTightHalo2015Filter', 'CSCTightHalo2015Filter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('CSCTightHaloFilter', 'CSCTightHaloFilter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('CSCTightHaloTrkMuUnvetoFilter', 'CSCTightHaloTrkMuUnvetoFilter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('EcalDeadCellBoundaryEnergyFilter', 'EcalDeadCellBoundaryEnergyFilter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('EcalDeadCellTriggerPrimitiveFilter', 'EcalDeadCellTriggerPrimitiveFilter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('HBHENoiseFilter', 'HBHENoiseFilter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('HBHENoiseIsoFilter', 'HBHENoiseIsoFilter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('HcalStripHaloFilter', 'HcalStripHaloFilter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('METFilters', 'METFilters', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('chargedHadronTrackResolutionFilter', 'chargedHadronTrackResolutionFilter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('ecalBadCalibFilter', 'ecalBadCalibFilter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('ecalBadCalibFilterV2', 'ecalBadCalibFilterV2', 1, 0.5, 1.5, 'Bad ECAL calib flag (updated xtal list)'),
                Plot1D('ecalLaserCorrFilter', 'ecalLaserCorrFilter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('eeBadScFilter', 'eeBadScFilter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('globalSuperTightHalo2016Filter', 'globalSuperTightHalo2016Filter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('globalTightHalo2016Filter', 'globalTightHalo2016Filter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('goodVertices', 'goodVertices', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('hcalLaserEventFilter', 'hcalLaserEventFilter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('muonBadTrackFilter', 'muonBadTrackFilter', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('trkPOGFilters', 'trkPOGFilters', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('trkPOG_logErrorTooManyClusters', 'trkPOG_logErrorTooManyClusters', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('trkPOG_manystripclus53X', 'trkPOG_manystripclus53X', 2, -0.5, 1.5, 'Trigger/flag bit'),
                Plot1D('trkPOG_toomanystripclus53X', 'trkPOG_toomanystripclus53X', 2, -0.5, 1.5, 'Trigger/flag bit'),
            )
        ),
        FsrPhoton = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Count1D('_size', 4, -0.5, 3.5, 'Final state radiation photons emitted by muons'),
                Plot1D('dROverEt2', 'dROverEt2', 20, 0, 0.05, 'deltaR to associated muon divided by photon et2'),
                Plot1D('eta', 'eta', 20, -2.5, 2.5, 'eta'),
                NoPlot('muonIdx'),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 40, 'pt'),
                Plot1D('relIso03', 'relIso03', 20, 0, 2, 'relative isolation in a 0.3 cone without CHS'),
            )
        ),
        GenDressedLepton = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Count1D('_size', 25, -0.5, 24.5, 'Dressed leptons from Rivet-based ParticleLevelProducer'),
                Plot1D('eta', 'eta', 20, -7, 7, 'eta'),
                Plot1D('hasTauAnc', 'hasTauAnc', 2, -0.5, 1.5, 'true if Dressed lepton has a tau as ancestor'),
                Plot1D('mass', 'mass', 20, 0, 200, 'mass'),
                Plot1D('pdgId', 'pdgId', 40, -20, 20, 'pdgId'),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 200, 'pt'),
            )
        ),
        GenIsolatedPhoton = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Count1D('_size', 10, -0.5, 9.5, 'Isolated photons from Rivet-based ParticleLevelProducer'),
                Plot1D('eta', 'eta', 20, -7, 7, 'eta'),
                NoPlot('mass'),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 200, 'pt'),
            )
        ),
        GenJet = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Count1D('_size', 25, -0.5, 24.5, 'slimmedGenJets, i.e. ak4 Jets made with visible genparticles'),
                Plot1D('eta', 'eta', 20, -7, 7, 'eta'),
                Plot1D('hadronFlavour', 'hadronFlavour', 6, -0.5, 5.5, 'flavour from hadron ghost clustering'),
                Plot1D('mass', 'mass', 20, 0, 200, 'mass'),
                Plot1D('partonFlavour', 'partonFlavour', 40, -9.5, 30.5, 'flavour from parton matching'),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 200, 'pt'),
            )
        ),
        GenJetAK8 = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Count1D('_size', 25, -0.5, 24.5, 'slimmedGenJetAK8, i.e. ak8 Jets made with visible genparticles'),
                Plot1D('eta', 'eta', 20, -7, 7, 'eta'),
                Plot1D('hadronFlavour', 'hadronFlavour', 6, -0.5, 5.5, 'flavour from hadron ghost clustering'),
                Plot1D('mass', 'mass', 20, 0, 200, 'mass'),
                Plot1D('partonFlavour', 'partonFlavour', 40, -9.5, 30.5, 'flavour from parton matching'),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 200, 'pt'),
            )
        ),
        GenMET = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 400, 'pt'),
            )
        ),
        GenPart = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Count1D('_size', 40, -0.5, 124.5, 'interesting gen particles '),
                Plot1D('eta', 'eta', 20, -30000, 30000, 'eta'),
                NoPlot('genPartIdxMother'),
                Plot1D('mass', 'mass', 20, 0, 300, 'Mass stored for all particles with mass > 10 GeV and photons with mass > 1 GeV. For other particles you can lookup from PDGID'),
                Plot1D('pdgId', 'pdgId', 20, -6000, 6000, 'PDG id'),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 200, 'pt'),
                Plot1D('status', 'status', 20, 0, 100, 'Particle status. 1=stable'),
                Plot1D('statusFlags', 'statusFlags', 32768, 0, 32768, 'gen status flags stored bitwise, bits are: 0 : isPrompt, 1 : isDecayedLeptonHadron, 2 : isTauDecayProduct, 3 : isPromptTauDecayProduct, 4 : isDirectTauDecayProduct, 5 : isDirectPromptTauDecayProduct, 6 : isDirectHadronDecayProduct, 7 : isHardProcess, 8 : fromHardProcess, 9 : isHardProcessTauDecayProduct, 10 : isDirectHardProcessTauDecayProduct, 11 : fromHardProcessBeforeFSR, 12 : isFirstCopy, 13 : isLastCopy, 14 : isLastCopyBeforeFSR, '),
            )
        ),
        GenVisTau = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Count1D('_size', 4, -0.5, 3.5, 'gen hadronic taus '),
                Plot1D('charge', 'charge', 3, -1.5, 1.5, 'charge'),
                Plot1D('eta', 'eta', 20, -5, 5, 'eta'),
                NoPlot('genPartIdxMother'),
                Plot1D('mass', 'mass', 20, 0, 2, 'mass'),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 200, 'pt'),
                Plot1D('status', 'status', 16, -0.5, 15.5, 'Hadronic tau decay mode. 0=OneProng0PiZero, 1=OneProng1PiZero, 2=OneProng2PiZero, 10=ThreeProng0PiZero, 11=ThreeProng1PiZero, 15=Other'),
            )
        ),
        IsoTrack = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Count1D('_size', 5, -0.5, 4.5, 'isolated tracks after basic selection (pt > 10 && abs(dxy) < 0.02 && abs(dz) < 0.1 && isHighPurityTrack && miniPFIsolation.chargedHadronIso/pt < 0.2) and lepton veto'),
                Plot1D('dxy', 'dxy', 20, -0.02, 0.02, 'dxy (with sign) wrt first PV, in cm'),
                Plot1D('dz', 'dz', 20, -0.09, 0.09, 'dz (with sign) wrt first PV, in cm'),
                Plot1D('eta', 'eta', 20, -3, 3, 'eta'),
                Plot1D('fromPV', 'fromPV', 5, -1.5, 3.5, 'provenance from primary vertex'),
                Plot1D('isFromLostTrack', 'isFromLostTrack', 2, -0.5, 1.5, 'if isolated track comes from a lost track'),
                Plot1D('isHighPurityTrack', 'isHighPurityTrack', 2, -0.5, 1.5, 'track is high purity'),
                Plot1D('isPFcand', 'isPFcand', 2, -0.5, 1.5, 'if isolated track is a PF candidate'),
                Plot1D('miniPFRelIso_all', 'miniPFRelIso_all', 20, 0, 2, 'mini PF relative isolation, total (with scaled rho*EA PU corrections)'),
                Plot1D('miniPFRelIso_chg', 'miniPFRelIso_chg', 20, 0, 2, 'mini PF relative isolation, charged component'),
                Plot1D('pdgId', 'pdgId', 20, -300, 300, 'PDG id of PF cand'),
                Plot1D('pfRelIso03_all', 'pfRelIso03_all', 20, 0, 2, 'PF relative isolation dR=0.3, total (deltaBeta corrections)'),
                Plot1D('pfRelIso03_chg', 'pfRelIso03_chg', 20, 0, 2, 'PF relative isolation dR=0.3, charged component'),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 200, 'pt'),
            )
        ),
        Jet = cms.PSet(
            sels = cms.PSet(
                CentralPt30 = cms.string('abs(eta) < 2.4 && pt > 30'),
                ForwardPt30 = cms.string('abs(eta) > 2.4 && pt > 30')
            ),
            plots = cms.VPSet(
                Count1D('_size', 20, -0.5, 19.5, 'slimmedJets, i.e. ak4 PFJets CHS with JECs applied, after basic selection (pt > 15)'),
                Plot1D('area', 'area', 20, 0.2, 0.8, 'jet catchment area, for JECs'),
                Plot1D('bRegCorr', 'bRegCorr', 20, 0, 3, 'pt correction for b-jet energy regression'),
                Plot1D('bRegRes', 'bRegRes', 20, 0, 0.6, 'res on pt corrected with b-jet regression'),
                Plot1D('btagCMVA', 'btagCMVA', 20, -1, 1, 'CMVA V2 btag discriminator'),
                Plot1D('btagCSVV2', 'btagCSVV2', 20, -1, 1, ' pfCombinedInclusiveSecondaryVertexV2 b-tag discriminator (aka CSVV2)'),
                Plot1D('btagDeepB', 'btagDeepB', 20, -1, 1, 'Deep B+BB btag discriminator'),
                Plot1D('btagDeepC', 'btagDeepC', 20, 0, 1, 'DeepCSV charm btag discriminator'),
                Plot1D('btagDeepFlavB', 'btagDeepFlavB', 20, 0, 1, 'DeepFlavour b+bb tag discriminator'),
                Plot1D('btagDeepFlavC', 'btagDeepFlavC', 20, 0, 1, 'DeepFlavour charm tag discriminator'),
                Plot1D('cRegCorr', 'cRegCorr', 20, 0.6, 2, 'pt correction for c-jet energy regression'),
                Plot1D('cRegRes', 'cRegRes', 20, 0.05, 0.4, 'res on pt corrected with c-jet regression'),
                Plot1D('chEmEF', 'chEmEF', 20, 0, 1, 'charged Electromagnetic Energy Fraction'),
                Plot1D('chFPV0EF', 'chFPV0EF', 20, 0, 2, 'charged fromPV==0 Energy Fraction (energy excluded from CHS jets). Previously called betastar.'),
                Plot1D('chFPV1EF', 'chFPV1EF', 20, 0, 1, 'charged fromPV==1 Energy Fraction (component of the total charged Energy Fraction).'),
                Plot1D('chFPV2EF', 'chFPV2EF', 20, 0, 1, 'charged fromPV==2 Energy Fraction (component of the total charged Energy Fraction).'),
                Plot1D('chFPV3EF', 'chFPV3EF', 20, 0, 1, 'charged fromPV==3 Energy Fraction (component of the total charged Energy Fraction).'),
                Plot1D('chHEF', 'chHEF', 20, 0, 2, 'charged Hadron Energy Fraction'),
                Plot1D('cleanmask', 'cleanmask', 2, -0.5, 1.5, 'simple cleaning mask with priority to leptons'),
                NoPlot('electronIdx1'),
                NoPlot('electronIdx2'),
                Plot1D('eta', 'eta', 20, -6, 6, 'eta'),
                NoPlot('genJetIdx'),
                Plot1D('hadronFlavour', 'hadronFlavour', 6, -0.5, 5.5, 'flavour from hadron ghost clustering'),
                Plot1D('jetId', 'jetId', 8, -0.5, 7.5, 'Jet ID flags bit1 is loose (always false in 2017 since it does not exist), bit2 is tight, bit3 is tightLepVeto'),
                Plot1D('mass', 'mass', 20, 0, 200, 'mass'),
                Plot1D('muEF', 'muEF', 20, 0, 1, 'muon Energy Fraction'),
                NoPlot('muonIdx1'),
                NoPlot('muonIdx2'),
                Plot1D('muonSubtrFactor', 'muonSubtrFactor', 20, 0, 1, '1-(muon-subtracted raw pt)/(raw pt)'),
                Plot1D('nConstituents', 'nConstituents', 20, 0, 80, 'Number of particles in the jet'),
                Plot1D('nElectrons', 'nElectrons', 5, -0.5, 4.5, 'number of electrons in the jet'),
                Plot1D('nMuons', 'nMuons', 4, -0.5, 3.5, 'number of muons in the jet'),
                Plot1D('neEmEF', 'neEmEF', 20, 0, 1, 'charged Electromagnetic EnergyFraction'),
                Plot1D('neHEF', 'neHEF', 20, 0, 1, 'neutral Hadron Energy Fraction'),
                Plot1D('partonFlavour', 'partonFlavour', 40, -9.5, 30.5, 'flavour from parton matching'),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 400, 'pt'),
                Plot1D('puId', 'puId', 8, -0.5, 7.5, 'Pilup ID flags'),
                Plot1D('puIdDisc', 'puIdDisc', 20, -1, 1, 'Pilup ID discriminant with 102X (2018) training'),
                Plot1D('qgl', 'qgl', 20, 0, 1, 'Quark vs Gluon likelihood discriminator'),
                Plot1D('rawFactor', 'rawFactor', 20, -0.5, 0.5, '1 - Factor to get back to raw pT'),
            )
        ),
        MET = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Plot1D('MetUnclustEnUpDeltaX', 'MetUnclustEnUpDeltaX', 20, -20, 20, 'Delta (METx_mod-METx) Unclustered Energy Up'),
                Plot1D('MetUnclustEnUpDeltaY', 'MetUnclustEnUpDeltaY', 20, -10, 10, 'Delta (METy_mod-METy) Unclustered Energy Up'),
                Plot1D('covXX', 'covXX', 20, 0, 40000, 'xx element of met covariance matrix'),
                Plot1D('covXY', 'covXY', 20, -8000, 8000, 'xy element of met covariance matrix'),
                Plot1D('covYY', 'covYY', 20, 0, 50000, 'yy element of met covariance matrix'),
                Plot1D('fiducialGenPhi', 'fiducialGenPhi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('fiducialGenPt', 'fiducialGenPt', 20, 0, 400, 'pt'),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 400, 'pt'),
                Plot1D('significance', 'significance', 20, 0, 200, 'MET significance'),
                Plot1D('sumEt', 'sumEt', 20, 600, 5000, 'scalar sum of Et'),
                Plot1D('sumPtUnclustered', 'sumPtUnclustered', 20, 0, 3000, 'sumPt used for MET significance'),
            )
        ),
        Muon = cms.PSet(
            sels = cms.PSet(
                Good = cms.string('pt > 15 && abs(dxy) < 0.2 && abs(dz) < 0.5 && mediumId && miniPFRelIso_all < 0.4')
            ),
            plots = cms.VPSet(
                Count1D('_size', 5, -0.5, 4.5, 'slimmedMuons after basic selection (pt > 3 && track.isNonnull && isLooseMuon)'),
                Plot1D('charge', 'charge', 3, -1.5, 1.5, 'electric charge'),
                Plot1D('cleanmask', 'cleanmask', 2, -0.5, 1.5, 'simple cleaning mask with priority to leptons'),
                Plot1D('dxy', 'dxy', 20, -0.1, 0.1, 'dxy (with sign) wrt first PV, in cm'),
                Plot1D('dxyErr', 'dxyErr', 20, 0, 0.1, 'dxy uncertainty, in cm'),
                Plot1D('dxybs', 'dxybs', 20, -0.1, 0.1, 'dxy (with sign) wrt the beam spot, in cm'),
                Plot1D('dz', 'dz', 20, -0.3, 0.3, 'dz (with sign) wrt first PV, in cm'),
                Plot1D('dzErr', 'dzErr', 20, 0, 0.2, 'dz uncertainty, in cm'),
                Plot1D('eta', 'eta', 20, -2.5, 2.5, 'eta'),
                NoPlot('fsrPhotonIdx'),
                Plot1D('genPartFlav', 'genPartFlav', 16, -0.5, 15.5, 'Flavour of genParticle for MC matching to status==1 muons: 1 = prompt muon (including gamma*->mu mu), 15 = muon from prompt tau, 5 = muon from b, 4 = muon from c, 3 = muon from light or unknown, 0 = unmatched'),
                NoPlot('genPartIdx'),
                Plot1D('highPtId', 'highPtId', 3, -0.5, 2.5, 'POG highPt muon ID (1 = tracker high pT, 2 = global high pT, which includes tracker high pT)'),
                Plot1D('highPurity', 'highPurity', 2, -0.5, 1.5, 'inner track is high purity'),
                Plot1D('inTimeMuon', 'inTimeMuon', 2, -0.5, 1.5, 'inTimeMuon ID'),
                Plot1D('ip3d', 'ip3d', 20, 0, 0.2, '3D impact parameter wrt first PV, in cm'),
                Plot1D('isGlobal', 'isGlobal', 2, -0.5, 1.5, 'muon is global muon'),
                Plot1D('isPFcand', 'isPFcand', 2, -0.5, 1.5, 'muon is PF candidate'),
                Plot1D('isTracker', 'isTracker', 2, -0.5, 1.5, 'muon is tracker muon'),
                NoPlot('jetIdx'),
                Plot1D('jetPtRelv2', 'jetPtRelv2', 20, 0, 30, 'Relative momentum of the lepton with respect to the closest jet after subtracting the lepton'),
                Plot1D('jetRelIso', 'jetRelIso', 20, -0.2, 1.8, 'Relative isolation in matched jet (1/ptRatio-1, pfRelIso04_all if no matched jet)'),
                Plot1D('looseId', 'looseId', 2, -0.5, 1.5, 'muon is loose muon'),
                NoPlot('mass'),
                Profile1D('mediumId', 'mediumId', 'pt', 16, 0, 80, 'POG Medium muon ID (using the relaxed cuts in the data Run 2016 B-F periods, and standard cuts elsewhere)'),
                Plot1D('mediumPromptId', 'mediumPromptId', 2, -0.5, 1.5, 'cut-based ID, medium prompt WP'),
                Plot1D('miniIsoId', 'miniIsoId', 5, -0.5, 4.5, 'MiniIso ID from miniAOD selector (1=MiniIsoLoose, 2=MiniIsoMedium, 3=MiniIsoTight, 4=MiniIsoVeryTight)'),
                Plot1D('miniPFRelIso_all', 'miniPFRelIso_all', 20, 0, 1, 'mini PF relative isolation, total (with scaled rho*EA PU corrections)'),
                Plot1D('miniPFRelIso_chg', 'miniPFRelIso_chg', 20, 0, 1, 'mini PF relative isolation, charged component'),
                Plot1D('multiIsoId', 'multiIsoId', 3, -0.5, 2.5, 'MultiIsoId from miniAOD selector (1=MultiIsoLoose, 2=MultiIsoMedium)'),
                Plot1D('mvaId', 'mvaId', 4, -0.5, 3.5, 'Mva ID from miniAOD selector (1=MvaLoose, 2=MvaMedium, 3=MvaTight)'),
                Plot1D('mvaLowPt', 'mvaLowPt', 20, -1, 1, 'Low pt muon ID score'),
                Plot1D('mvaTTH', 'mvaTTH', 20, -1, 1, 'TTH MVA lepton ID score'),
                Plot1D('nStations', 'nStations', 5, -0.5, 4.5, 'number of matched stations with default arbitration (segment & track)'),
                Plot1D('nTrackerLayers', 'nTrackerLayers', 15, 2.5, 17.5, 'number of layers in the tracker'),
                Plot1D('pdgId', 'pdgId', 27, -13.5, 13.5, 'PDG code assigned by the event reconstruction (not by MC truth)'),
                Plot1D('pfIsoId', 'pfIsoId', 7, -0.5, 6.5, 'PFIso ID from miniAOD selector (1=PFIsoVeryLoose, 2=PFIsoLoose, 3=PFIsoMedium, 4=PFIsoTight, 5=PFIsoVeryTight, 6=PFIsoVeryVeryTight)'),
                Plot1D('pfRelIso03_all', 'pfRelIso03_all', 20, 0, 2, 'PF relative isolation dR=0.3, total (deltaBeta corrections)'),
                Plot1D('pfRelIso03_chg', 'pfRelIso03_chg', 20, 0, 2, 'PF relative isolation dR=0.3, charged component'),
                Plot1D('pfRelIso04_all', 'pfRelIso04_all', 20, 0, 2, 'PF relative isolation dR=0.4, total (deltaBeta corrections)'),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 200, 'pt'),
                Plot1D('ptErr', 'ptErr', 20, 0, 20, 'ptError of the muon track'),
                Plot1D('segmentComp', 'segmentComp', 20, 0, 1, 'muon segment compatibility'),
                Plot1D('sip3d', 'sip3d', 20, 0, 20, '3D impact parameter significance wrt first PV'),
                Profile1D('softId', 'softId', 'pt', 20, 0, 40, 'POG Soft muon ID (using the relaxed cuts in the data Run 2016 B-F periods, and standard cuts elsewhere)'),
                Plot1D('softMva', 'softMva', 20, -1, 1, 'soft MVA ID score'),
                Plot1D('softMvaId', 'softMvaId', 2, -0.5, 1.5, 'soft MVA ID'),
                Plot1D('tightCharge', 'tightCharge', 1, 1.5, 2.5, 'Tight charge criterion using pterr/pt of muonBestTrack (0:fail, 2:pass)'),
                Profile1D('tightId', 'tightId', 'pt', 16, 0, 80, 'POG Tight muon ID'),
                Plot1D('tkIsoId', 'tkIsoId', 3, -0.5, 2.5, 'TkIso ID (1=TkIsoLoose, 2=TkIsoTight)'),
                Plot1D('tkRelIso', 'tkRelIso', 100, 0, 1, 'Tracker-based relative isolation dR=0.3 for highPt, trkIso/tunePpt'),
                Plot1D('triggerIdLoose', 'triggerIdLoose', 2, -0.5, 1.5, 'TriggerIdLoose ID'),
                Plot1D('tunepRelPt', 'tunepRelPt', 200, 0, 200, 'TuneP relative pt, tunePpt/pt'),
            )
        ),
        OtherPV = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                NoPlot('_size'),
                Plot1D('z', 'z', 20, -20, 20, 'Z position of other primary vertices, excluding the main PV'),
            )
        ),
        PSWeight = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Plot1D('', '', 20, 0, 2, 'All PS weights (w_var / w_nominal)'),
                Count1D('_size', 46, -0.5, 45.5, 'Number of PS weights'),
            )
        ),
        PV = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Plot1D('chi2', 'chi2', 20, 0.5, 3, 'main primary vertex reduced chi2'),
                Plot1D('ndof', 'ndof', 20, 0, 500, 'main primary vertex number of degree of freedom'),
                Plot1D('npvs', 'npvs', 20, 0, 60, 'total number of reconstructed primary vertices'),
                Plot1D('npvsGood', 'npvsGood', 20, 0, 60, 'total number of Good primary vertices'),
                Plot1D('score', 'score', 20, 0, 300000, 'main primary vertex score, i.e. sum pt2 of clustered objects'),
                Plot1D('x', 'x', 20, -0.3, 0.3, 'main primary vertex position x coordinate'),
                Plot1D('y', 'y', 20, -0.3, 0.3, 'main primary vertex position y coordinate'),
                Plot1D('z', 'z', 20, -20, 20, 'main primary vertex position z coordinate'),
            )
        ),
        Photon = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Count1D('_size', 9, -0.5, 8.5, 'slimmedPhotons after basic selection (pt > 5 )'),
                Plot1D('charge', 'charge', 1, -0.5, 0.5, 'electric charge'),
                Plot1D('cleanmask', 'cleanmask', 1, 0.5, 1.5, 'simple cleaning mask with priority to leptons'),
                Plot1D('cutBased', 'cutBased', 4, -0.5, 3.5, 'cut-based ID bitmap, Fall17V2, (0:fail, 1:loose, 2:medium, 3:tight)'),
                Plot1D('cutBased_Fall17V1Bitmap', 'cutBased_Fall17V1Bitmap', 8, -0.5, 7.5, 'cut-based ID bitmap, Fall17V1, 2^(0:loose, 1:medium, 2:tight).'),
                Plot1D('eCorr', 'eCorr', 20, 0.8, 1.2, 'ratio of the calibrated energy/miniaod energy'),
                NoPlot('electronIdx'),
                Plot1D('electronVeto', 'electronVeto', 2, -0.5, 1.5, 'pass electron veto'),
                Plot1D('energyErr', 'energyErr', 20, 0, 300, 'energy error of the cluster from regression'),
                Plot1D('eta', 'eta', 20, -3, 3, 'eta'),
                Plot1D('genPartFlav', 'genPartFlav', 14, -0.5, 13.5, 'Flavour of genParticle for MC matching to status==1 photons or electrons: 1 = prompt photon, 13 = prompt electron, 0 = unknown or unmatched'),
                NoPlot('genPartIdx'),
                Plot1D('hoe', 'hoe', 20, 0, 0.6, 'H over E'),
                Plot1D('isScEtaEB', 'isScEtaEB', 2, -0.5, 1.5, 'is supercluster eta within barrel acceptance'),
                Plot1D('isScEtaEE', 'isScEtaEE', 2, -0.5, 1.5, 'is supercluster eta within endcap acceptance'),
                NoPlot('jetIdx'),
                NoPlot('mass'),
                Plot1D('mvaID', 'mvaID', 20, -1, 1, 'MVA ID score'),
                Plot1D('mvaID_Fall17V1p1', 'mvaID_Fall17V1p1', 20, -1, 1, 'MVA ID score, Fall17V1p1'),
                Plot1D('mvaID_WP80', 'mvaID_WP80', 2, -0.5, 1.5, 'MVA ID WP80'),
                Plot1D('mvaID_WP90', 'mvaID_WP90', 2, -0.5, 1.5, 'MVA ID WP90'),
                Plot1D('pdgId', 'pdgId', 1, 21.5, 22.5, 'PDG code assigned by the event reconstruction (not by MC truth)'),
                Plot1D('pfRelIso03_all', 'pfRelIso03_all', 20, 0, 2, 'PF relative isolation dR=0.3, total (with rho*EA PU corrections)'),
                Plot1D('pfRelIso03_chg', 'pfRelIso03_chg', 20, 0, 2, 'PF relative isolation dR=0.3, charged component (with rho*EA PU corrections)'),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pixelSeed', 'pixelSeed', 2, -0.5, 1.5, 'has pixel seed'),
                Plot1D('pt', 'pt', 20, 0, 200, 'pt (corrected)'),
                Plot1D('r9', 'r9', 20, 0, 1.1, 'R9 of the supercluster, calculated with full 5x5 region'),
                Plot1D('seedGain', 'seedGain', 12, 0.5, 12.5, 'Gain of the seed crystal'),
                Plot1D('sieie', 'sieie', 20, 0, 0.05, 'sigma_IetaIeta of the supercluster, calculated with full 5x5 region'),
                NoPlot('vidNestedWPBitmap'),
            )
        ),
        Pileup = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Plot1D('gpudensity', 'gpudensity', 20, 0, 0.9, 'Generator-level PU vertices / mm'),
                Plot1D('nPU', 'nPU', 20, 0, 60, 'the number of pileup interactions that have been added to the event in the current bunch crossing'),
                Plot1D('nTrueInt', 'nTrueInt', 20, 0, 60, 'the true mean number of the poisson distribution for this event from which the number of interactions each bunch crossing has been sampled'),
                Plot1D('pudensity', 'pudensity', 5, -0.5, 4.5, 'PU vertices / mm'),
                Plot1D('sumEOOT', 'sumEOOT', 20, 0, 800, 'number of early out of time pileup'),
                Plot1D('sumLOOT', 'sumLOOT', 20, 0, 300, 'number of late out of time pileup'),
            )
        ),
        PuppiMET = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('phiJERUp', 'phiJERUp', 20, -3.14159, 3.14159, 'JER up phi'),
                Plot1D('phiJESUp', 'phiJESUp', 20, -3.14159, 3.14159, 'JES up phi'),
                Plot1D('pt', 'pt', 20, 0, 400, 'pt'),
                Plot1D('ptJERUp', 'ptJERUp', 20, 0, 400, 'JER up pt'),
                Plot1D('ptJESUp', 'ptJESUp', 20, 0, 400, 'JES up pt'),
                Plot1D('sumEt', 'sumEt', 20, 200, 3000, 'scalar sum of Et'),
            )
        ),
        RawMET = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 400, 'pt'),
                Plot1D('sumEt', 'sumEt', 20, 400, 4000, 'scalar sum of Et'),
            )
        ),
        RawPuppiMET = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 400, 'pt'),
                Plot1D('sumEt', 'sumEt', 20, 400, 4000, 'scalar sum of Et'),
            )
        ),
        SV = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Count1D('_size', 14, -0.5, 13.5),
                Plot1D('chi2', 'chi2', 20, -2000, 2000, 'reduced chi2, i.e. chi/ndof'),
                Plot1D('dlen', 'dlen', 20, 0, 4, 'decay length in cm'),
                Plot1D('dlenSig', 'dlenSig', 20, 0, 50, 'decay length significance'),
                Plot1D('dxy', 'dxy', 20, 0, 4, '2D decay length in cm'),
                Plot1D('dxySig', 'dxySig', 20, 0, 50, '2D decay length significance'),
                Plot1D('eta', 'eta', 20, -3, 3, 'eta'),
                Plot1D('mass', 'mass', 20, 0, 8, 'mass'),
                Plot1D('ndof', 'ndof', 20, -1, 19, 'number of degrees of freedom'),
                Plot1D('pAngle', 'pAngle', 20, -3.1416, 3.1416, 'pointing angle, i.e. acos(p_SV * (SV - PV)) '),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 200, 'pt'),
                Plot1D('x', 'x', 20, -0.5, 0.5, 'secondary vertex X position, in cm'),
                Plot1D('y', 'y', 20, -0.5, 0.5, 'secondary vertex Y position, in cm'),
                Plot1D('z', 'z', 20, -10, 10, 'secondary vertex Z position, in cm'),
            )
        ),
        SoftActivityJet = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Count1D('_size', 7, -0.5, 6.5, 'jets clustered from charged candidates compatible with primary vertex (charge()!=0 && pvAssociationQuality()>=5 && vertexRef().key()==0)'),
                Plot1D('eta', 'eta', 20, -3, 3, 'eta'),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 200, 'pt'),
            )
        ),
        SubJet = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Count1D('_size', 9, -0.5, 8.5, 'slimmedJetsAK8, i.e. ak8 fat jets for boosted analysis'),
                Plot1D('btagCMVA', 'btagCMVA', 20, -1, 1, 'CMVA V2 btag discriminator'),
                Plot1D('btagCSVV2', 'btagCSVV2', 20, -1, 1, ' pfCombinedInclusiveSecondaryVertexV2 b-tag discriminator (aka CSVV2)'),
                Plot1D('btagDeepB', 'btagDeepB', 20, -1, 1, 'Deep B+BB btag discriminator'),
                Plot1D('eta', 'eta', 20, -4, 4, 'eta'),
                Plot1D('mass', 'mass', 20, -200, 200, 'mass'),
                Plot1D('n2b1', 'n2b1', 20, 0, 1, 'N2 (beta=1)'),
                Plot1D('n3b1', 'n3b1', 20, 0, 5, 'N3 (beta=1)'),
                Plot1D('nBHadrons', 'nBHadrons', 4, -0.5, 3.5, 'number of b-hadrons'),
                Plot1D('nCHadrons', 'nCHadrons', 4, -0.5, 3.5, 'number of c-hadrons'),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 200, 'pt'),
                Plot1D('rawFactor', 'rawFactor', 20, -0.5, 0.5, '1 - Factor to get back to raw pT'),
                Plot1D('tau1', 'tau1', 20, 0, 1, 'Nsubjettiness (1 axis)'),
                Plot1D('tau2', 'tau2', 20, 0, 1, 'Nsubjettiness (2 axis)'),
                Plot1D('tau3', 'tau3', 20, 0, 1, 'Nsubjettiness (3 axis)'),
                Plot1D('tau4', 'tau4', 20, 0, 1, 'Nsubjettiness (4 axis)'),
            )
        ),
        Tau = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Count1D('_size', 7, -0.5, 6.5, "slimmedTaus after basic selection (pt > 18 && tauID('decayModeFindingNewDMs') && (tauID('byLooseCombinedIsolationDeltaBetaCorr3Hits') || tauID('byVLooseIsolationMVArun2v1DBoldDMwLT') || tauID('byVLooseIsolationMVArun2v1DBnewDMwLT') || tauID('byVLooseIsolationMVArun2v1DBdR03oldDMwLT')))"),
                Plot1D('charge', 'charge', 3, -1.5, 1.5, 'electric charge'),
                Plot1D('chargedIso', 'chargedIso', 20, 0, 200, 'charged isolation'),
                Plot1D('cleanmask', 'cleanmask', 1, 0.5, 1.5, 'simple cleaning mask with priority to leptons'),
                Plot1D('decayMode', 'decayMode', 12, -0.5, 11.5, 'decayMode()'),
                Plot1D('dxy', 'dxy', 20, -1000, 1000, 'd_{xy} of lead track with respect to PV, in cm (with sign)'),
                Plot1D('dz', 'dz', 20, -20, 20, 'd_{z} of lead track with respect to PV, in cm (with sign)'),
                Plot1D('eta', 'eta', 20, -3, 3, 'eta'),
                Plot1D('genPartFlav', 'genPartFlav', 6, -0.5, 5.5, 'Flavour of genParticle for MC matching to status==2 taus: 1 = prompt electron, 2 = prompt muon, 3 = tau->e decay, 4 = tau->mu decay, 5 = hadronic tau decay, 0 = unknown or unmatched'),
                NoPlot('genPartIdx'),
                Plot1D('idAntiEle', 'idAntiEle', 32, -0.5, 31.5, 'Anti-electron MVA discriminator V6: bitmask 1 = VLoose, 2 = Loose, 4 = Medium, 8 = Tight, 16 = VTight'),
                Plot1D('idAntiEle2018', 'idAntiEle2018', 32, -0.5, 31.5, 'Anti-electron MVA discriminator V6 (2018): bitmask 1 = VLoose, 2 = Loose, 4 = Medium, 8 = Tight, 16 = VTight'),
                Plot1D('idAntiMu', 'idAntiMu', 4, -0.5, 3.5, 'Anti-muon discriminator V3: : bitmask 1 = Loose, 2 = Tight'),
                Plot1D('idDecayMode', 'idDecayMode', 2, -0.5, 1.5, "tauID('decayModeFinding')"),
                Plot1D('idDecayModeNewDMs', 'idDecayModeNewDMs', 2, -0.5, 1.5, "tauID('decayModeFindingNewDMs')"),
                Plot1D('idDeepTau2017v2p1VSe', 'idDeepTau2017v2p1VSe', 256, -0.5, 255.5, 'byDeepTau2017v2p1VSe ID working points (deepTau2017v2p1): bitmask 1 = VVVLoose, 2 = VVLoose, 4 = VLoose, 8 = Loose, 16 = Medium, 32 = Tight, 64 = VTight, 128 = VVTight'),
                Plot1D('idDeepTau2017v2p1VSjet', 'idDeepTau2017v2p1VSjet', 256, -0.5, 255.5, 'byDeepTau2017v2p1VSjet ID working points (deepTau2017v2p1): bitmask 1 = VVVLoose, 2 = VVLoose, 4 = VLoose, 8 = Loose, 16 = Medium, 32 = Tight, 64 = VTight, 128 = VVTight'),
                Plot1D('idDeepTau2017v2p1VSmu', 'idDeepTau2017v2p1VSmu', 16, -0.5, 15.5, 'byDeepTau2017v2p1VSmu ID working points (deepTau2017v2p1): bitmask 1 = VLoose, 2 = Loose, 4 = Medium, 8 = Tight'),
                Plot1D('idMVAnewDM2017v2', 'idMVAnewDM2017v2', 128, -0.5, 127.5, 'IsolationMVArun2v1DBnewDMwLT ID working point (2017v2): bitmask 1 = VVLoose, 2 = VLoose, 4 = Loose, 8 = Medium, 16 = Tight, 32 = VTight, 64 = VVTight'),
                Plot1D('idMVAoldDM', 'idMVAoldDM', 64, -0.5, 63.5, 'IsolationMVArun2v1DBoldDMwLT ID working point: bitmask 1 = VLoose, 2 = Loose, 4 = Medium, 8 = Tight, 16 = VTight, 32 = VVTight'),
                Plot1D('idMVAoldDM2017v1', 'idMVAoldDM2017v1', 128, -0.5, 127.5, 'IsolationMVArun2v1DBoldDMwLT ID working point (2017v1): bitmask 1 = VVLoose, 2 = VLoose, 4 = Loose, 8 = Medium, 16 = Tight, 32 = VTight, 64 = VVTight'),
                Plot1D('idMVAoldDM2017v2', 'idMVAoldDM2017v2', 128, -0.5, 127.5, 'IsolationMVArun2v1DBoldDMwLT ID working point (2017v2): bitmask 1 = VVLoose, 2 = VLoose, 4 = Loose, 8 = Medium, 16 = Tight, 32 = VTight, 64 = VVTight'),
                Plot1D('idMVAoldDMdR032017v2', 'idMVAoldDMdR032017v2', 128, -0.5, 127.5, 'IsolationMVArun2v1DBdR03oldDMwLT ID working point (217v2): bitmask 1 = VVLoose, 2 = VLoose, 4 = Loose, 8 = Medium, 16 = Tight, 32 = VTight, 64 = VVTight'),
                NoPlot('jetIdx'),
                Plot1D('leadTkDeltaEta', 'leadTkDeltaEta', 20, -0.1, 0.1, 'eta of the leading track, minus tau eta'),
                Plot1D('leadTkDeltaPhi', 'leadTkDeltaPhi', 20, -0.1, 0.1, 'phi of the leading track, minus tau phi'),
                Plot1D('leadTkPtOverTauPt', 'leadTkPtOverTauPt', 20, 0, 2, 'pt of the leading track divided by tau pt'),
                Plot1D('mass', 'mass', 20, 0, 5, 'mass'),
                Plot1D('neutralIso', 'neutralIso', 20, 0, 200, 'neutral (photon) isolation'),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('photonsOutsideSignalCone', 'photonsOutsideSignalCone', 20, 0, 30, 'sum of photons outside signal cone'),
                Plot1D('pt', 'pt', 20, 0, 200, 'pt'),
                Plot1D('puCorr', 'puCorr', 20, 0, 90, 'pileup correction'),
                Plot1D('rawAntiEle', 'rawAntiEle', 20, -100, 100, 'Anti-electron MVA discriminator V6 raw output discriminator'),
                Plot1D('rawAntiEle2018', 'rawAntiEle2018', 20, -100, 100, 'Anti-electron MVA discriminator V6 raw output discriminator (2018)'),
                Plot1D('rawAntiEleCat', 'rawAntiEleCat', 17, -1.5, 15.5, 'Anti-electron MVA discriminator V6 category'),
                Plot1D('rawAntiEleCat2018', 'rawAntiEleCat2018', 17, -1.5, 15.5, 'Anti-electron MVA discriminator V6 category (2018)'),
                Plot1D('rawDeepTau2017v2p1VSe', 'rawDeepTau2017v2p1VSe', 20, 0, 1, 'byDeepTau2017v2p1VSe raw output discriminator (deepTau2017v2p1)'),
                Plot1D('rawDeepTau2017v2p1VSjet', 'rawDeepTau2017v2p1VSjet', 20, 0, 1, 'byDeepTau2017v2p1VSjet raw output discriminator (deepTau2017v2p1)'),
                Plot1D('rawDeepTau2017v2p1VSmu', 'rawDeepTau2017v2p1VSmu', 20, 0, 1, 'byDeepTau2017v2p1VSmu raw output discriminator (deepTau2017v2p1)'),
                Plot1D('rawIso', 'rawIso', 20, 0, 200, 'combined isolation (deltaBeta corrections)'),
                Plot1D('rawIsodR03', 'rawIsodR03', 20, 0, 200, 'combined isolation (deltaBeta corrections, dR=0.3)'),
                Plot1D('rawMVAnewDM2017v2', 'rawMVAnewDM2017v2', 20, -1, 1, 'byIsolationMVArun2v1DBnewDMwLT raw output discriminator (2017v2)'),
                Plot1D('rawMVAoldDM', 'rawMVAoldDM', 20, -1, 1, 'byIsolationMVArun2v1DBoldDMwLT raw output discriminator'),
                Plot1D('rawMVAoldDM2017v1', 'rawMVAoldDM2017v1', 20, -1, 1, 'byIsolationMVArun2v1DBoldDMwLT raw output discriminator (2017v1)'),
                Plot1D('rawMVAoldDM2017v2', 'rawMVAoldDM2017v2', 20, -1, 1, 'byIsolationMVArun2v1DBoldDMwLT raw output discriminator (2017v2)'),
                Plot1D('rawMVAoldDMdR032017v2', 'rawMVAoldDMdR032017v2', 20, -1, 1, 'byIsolationMVArun2v1DBdR03oldDMwLT raw output discriminator (2017v2)'),
            )
        ),
        TkMET = cms.PSet(
            sels = cms.PSet(),
            plots = cms.VPSet(
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 20, 0, 400, 'pt'),
                Plot1D('sumEt', 'sumEt', 20, 0, 2000, 'scalar sum of Et'),
            )
        ),
        TrigObj = cms.PSet(
            sels = cms.PSet(
                Electron = cms.string('id == 11'),
                HT = cms.string('id == 3'),
                Jet = cms.string('id == 1'),
                MET = cms.string('id == 2'),
                MHT = cms.string('id == 4'),
                Muon = cms.string('id == 13'),
                Photon = cms.string('id == 22'),
                Tau = cms.string('id == 15')
            ),
            plots = cms.VPSet(
                Count1D('_size', 28, -0.5, 27.5),
                Plot1D('eta', 'eta', 20, -5, 5, 'eta'),
                Plot1D('filterBits', 'filterBits', 1024, -0.5, 1023.5, 'extra bits of associated information: 1 = CaloIdL_TrackIdL_IsoVL, 2 = WPLoose, 4 = WPTight, 8 = OverlapFilter PFTau for Electron (PixelMatched e/gamma); 1 = TrkIsoVVL, 2 = Iso, 4 = OverlapFilter PFTau for Muon; 1 = LooseChargedIso, 2 = MediumChargedIso, 4 = TightChargedIso, 8 = TightID OOSC photons, 16 = L2p5 pixel iso, 32 = OverlapFilter IsoMu, 64 = OverlapFilter IsoEle, 128 = L1-HLT matched, 256 = Dz for Tau; 1 = VBF cross-cleaned from loose iso PFTau for Jet'),
                Plot1D('id', 'id', 20, 0, 30, 'ID of the object: 11 = Electron (PixelMatched e/gamma), 22 = Photon (PixelMatch-vetoed e/gamma), 13 = Muon, 14 = Tau, 1 = Jet, 2 = MET, 3 = HT, 4 = MHT'),
                Plot1D('l1charge', 'l1charge', 3, -1.5, 1.5, 'charge of associated L1 seed'),
                Plot1D('l1iso', 'l1iso', 4, -0.5, 3.5, 'iso of associated L1 seed'),
                Plot1D('l1pt', 'l1pt', 20, 0, 200, 'pt of associated L1 seed'),
                Plot1D('l1pt_2', 'l1pt_2', 20, 0, 200, 'pt of associated secondary L1 seed'),
                Plot1D('l2pt', 'l2pt', 20, 0, 200, "pt of associated 'L2' seed (i.e. HLT before tracking/PF)"),
                Plot1D('phi', 'phi', 20, -3.14159, 3.14159, 'phi'),
                Plot1D('pt', 'pt', 40, 0, 400, 'pt'),
            )
        ),
    )
)
